package application;

/**
 * @author bouchaib.lemaire
 * version 2017-2018
 */
import controleur.ControleurMorpionTextuel;
import controleur.InterfaceControleurMorpion;
import modele.InterfaceModeleMorpion;
import modele.ModeleMorpion;
import vue.InterfaceVueMorpion;
import vue.VueMorpionGraphique;
import vue.VueMorpionTextuel;

public abstract class TestMorpion 
{

	public static void main(String[] args) 
	{
		
		/**
		 * Instanciation du modèle		
		 */
		InterfaceModeleMorpion modeleJeuMorpion      = new ModeleMorpion() ;		

		
		
		/** **********************************
		 *  Mise en place de la vue textuelle
		 *  C'est une vue "active" donc un contrôleur
		 *  est nécessaire pour gérer l'intéraction
		 *  avec l'utilisateur
		    ********************************** */
		
		/**
		 * Instanciation du contrôleur avec :
		 * - Liaison Contrôleur -> Modèle (pour que le contrôleur
		 *   puisse demander des changements d'états du modèle  
		 */
		InterfaceControleurMorpion controleurVueTextuelle = new ControleurMorpionTextuel(modeleJeuMorpion) ;
		
		/**
		 * Instanciation de la vue textuelle :
		 * - Liaison Vue -> Contrôleur (pour gérer l'intéraction
		 *   utilisateur)
		 * - Lisaison Vue -> Modèle (pour implémenter la méthode
		 *   				 "pull")
		 *    
		 */
		InterfaceVueMorpion vueTextuelle        = new VueMorpionTextuel(controleurVueTextuelle, modeleJeuMorpion) ;
		
		
		
		/**
		 * Liaison Contrôleur -> Vue (pour que le contrôleur puisse
		 * 						 envoyer des requêtes à la vue par
		 *                       exemple pour demander son activation etc.)
		 */
		controleurVueTextuelle.setVue(vueTextuelle) ;
		
		
		/**
		 * Instanciation de la vue graphique :
		 * - Lisaison Vue -> Modèle (pour implémenter la méthode
		 *   				 "pull")
		 * Pas de contrôleur dans cette version car c'est une vue "passive" 
		 */
		InterfaceVueMorpion vueGraphique        = new VueMorpionGraphique(modeleJeuMorpion) ;


		
	
		/**
		 * La vue vueTextuelle s'active
		 */
		vueTextuelle.activerVue() ;
		

		/**
		 * La vue vueGraphiquz s'active
		 */
		vueGraphique.activerVue();


		
	}	

}
